#
# Comment formatting
#

package provide Comment 0.1;

class Comment {

  import Indent;
  import Output;
  import sc_getPrefString;

  set cvs(1)       "XXX   %Z%%M% version %I% date:%G%"
  set copyright(1) [sc_getPrefString "CodeGen" "copyright_message" {}];

    if { $copyright(1) == "" } {
	set copyright(1) "Copyright (c) 1998 Helsinki University of Technology.
All rights reserved.

Redistribution and use in source and binary forms are permitted
provided that the above copyright notice and this paragraph are
duplicated in all such forms and that any documentation,
advertising materials, and other materials related to such
distribution and use acknowledge that the software was developed
by Helsinki University of Technology, Espoo.  The name of the
University may not be used to endorse or promote products derived
from this software without specific prior written permission.
THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
";
    }

  staticmethod print {what {str {}}} {
    switch "$what" {
      begin       { Output print "/**";  Indent more; }
      end         { Indent less; Output print "*/"; }

      line	  { Output print "$str"; }
      text        { Output printText $str; }
      array       { print_array str; }

      cvs         { print_array cvs; }
      copyright   { print_array copyright; }
      description { print begin; print text $str; print end; }
    }
  }

  staticmethod print_array {name} {
    upvar $name array;
 
    foreach index [lsort [array names array]] {
      Output print "$array($index)";
    }
  }
}
